/*
 * Copyright (C) 2008-2012 AgroSense Foundation.
 *
 * AgroSense is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * There are special exceptions to the terms and conditions of the GPLv3 as it is applied to
 * this software, see the FLOSS License Exception
 * <http://www.agrosense.eu/foss-exception.html>.
 *
 * AgroSense is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with AgroSense.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * Contributors:
 *    Timon Veenstra <monezz@gmail.com> - initial API and implementation and/or initial documentation
 */
package nl.cloudfarming.client.util;

import java.awt.Image;
import org.openide.nodes.FilterNode;
import org.openide.nodes.Node;
import org.openide.util.Lookup;

/**
 *
 * @author Timon Veenstra <monezz@gmail.com>
 */
public class ValidatingFilterNode extends FilterNode {
    
    private enum State {
        VALID,INVALID,UPDATING;
    }
    private State state;
    

    public ValidatingFilterNode(Node original) {
        super(original);
    }

    public ValidatingFilterNode(Node original, org.openide.nodes.Children children) {
        super(original, children);
    }

    public ValidatingFilterNode(Node original, org.openide.nodes.Children children, Lookup lookup) {
        super(original, children, lookup);
    }
    
    public boolean isValid(){
        return State.VALID.equals(this.state);
    }
    
    public boolean isUpdating(){
        return State.UPDATING.equals(this.state);
    } 
    
    

    @Override
    public Image getIcon(int type) {
        return super.getIcon(type);
    }
    
    
    
}
